/*
 * AUTHOR: Pedro Lineu Orso                         pedro.orso@gmail.com
 *                                                            1998, 2008
 * SARG Squid Analysis Report Generator      http://sarg.sourceforge.net
 *
 * SARG donations:
 *      please look at http://sarg.sourceforge.net/donations.php
 * ---------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 *
 */

#include "include/conf.h"
void getword(char *word, char *line, int stop, int limit);
void fixnone(char *str);
void ccharset();
void debuga(char *msg);
void language_load(char *language);

extern numlist hours, weekdays;

char wbuf[MAXLEN];
char Msg[255];

void parmtest(char *buf)
{

      if(strstr(buf,"background_color") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(BgColor,buf);
         fixnone(BgColor);
         return;
      }

      if(strstr(buf,"text_color") != 0) {
         if(strstr(buf,"logo_text_color") == 0) {
            getword(wbuf,buf,' ',sizeof(wbuf));
            strcpy(TxColor,buf);
            fixnone(TxColor);
            return;
         }
      }

      if(strstr(buf,"text_bgcolor") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(TxBgColor,buf);
         fixnone(TxBgColor);
         return;
      }

      if(strstr(buf,"title_color") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(TiColor,buf);
         fixnone(TiColor);
         return;
      }

      if(strstr(buf,"logo_image") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(LogoImage,buf);
         fixnone(LogoImage);
         return;
      }

      if(strstr(buf,"logo_text") != 0) {
         if(strstr(buf,"logo_text_color") == 0) {
            getword(wbuf,buf,'"',sizeof(wbuf));
            getword(LogoText,buf,'"',sizeof(LogoText));
            fixnone(LogoText);
            return;
         }
      }

      if(strstr(buf,"logo_text_color") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(LogoTextColor,buf);
         fixnone(LogoTextColor);
         return;
      }

      if(strstr(buf,"background_image") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(BgImage,buf);
         fixnone(BgImage);
         return;
      }

      if(strstr(buf,"show_sarg_info") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ShowSargInfo,buf);
         fixnone(ShowSargInfo);
         return;
      }

      if(strstr(buf,"show_sarg_logo") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ShowSargLogo,buf);
         fixnone(ShowSargLogo);
         return;
      }

      if(strstr(buf,"font_face") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(FontFace,buf);
         fixnone(FontFace);
         return;
      }

      if(strstr(buf,"header_color") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(HeaderColor,buf);
         fixnone(HeaderColor);
         return;
      }

      if(strstr(buf,"header_bgcolor") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(HeaderBgColor,buf);
         fixnone(HeaderBgColor);
         return;
      }

      if(strstr(buf,"font_size") != 0) {
         if(strstr(buf,"header_font_size") == 0 && strstr(buf,"title_font_size") == 0) {
            getword(wbuf,buf,' ',sizeof(wbuf));
            strcpy(FontSize,buf);
            fixnone(FontSize);
            return;
         }
      }

      if(strstr(buf,"header_font_size") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(HeaderFontSize,buf);
         fixnone(HeaderFontSize);
         return;
      }

      if(strstr(buf,"title_font_size") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(TitleFontSize,buf);
         fixnone(TitleFontSize);
         return;
      }

      if(strstr(buf,"image_size") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         getword(Width,buf,' ',sizeof(Width));
         strcpy(Height,buf);
         fixnone(Width);
         fixnone(Height);
         return;
      }

      if(strstr(buf,"title") != 0) {
         getword(wbuf,buf,'"',sizeof(wbuf));
         getword(Title,buf,'"',sizeof(Title));
         fixnone(Title);
         return;
      }

      if(strstr(buf,"resolve_ip") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(Ip2Name,buf);
         fixnone(Ip2Name);
         return;
      }

      if(strstr(buf,"user_ip") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(UserIp,buf);
         fixnone(UserIp);
         return;
      }

      if(strstr(buf,"max_elapsed") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(MaxElapsed,buf);
         fixnone(MaxElapsed);
         return;
      }

      if(strstr(buf,"date_format") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strncpy(DateFormat,buf,1);
         fixnone(DateFormat);
         return;
      }

      if( strstr( buf, "hours" ) != 0 ) {
         if( getnumlist( buf, &hours, 24, 24 ) ) {
            fprintf( stderr, "Error: Invalid syntax in hours tag!\n" );
            exit( 1 );
         }
       }

      if( strstr( buf, "weekdays" ) != 0 ) {
         if( getnumlist( buf, &weekdays, 7, 7 ) ) {
            fprintf( stderr, "Error: Invalid syntax in weekdays tag!\n" );
            exit( 1 );
         }
      }

      if(strstr(buf,"topuser_sort_field") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         getword(TopuserSortField,buf,' ',sizeof(TopuserSortField));
         strcpy(TopuserSortOrder,buf);
         fixnone(TopuserSortOrder);
         return;
      }

      if(strstr(buf,"user_sort_field") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         getword(UserSortField,buf,' ',sizeof(UserSortField));
         strcpy(UserSortOrder,buf);
         fixnone(UserSortOrder);
         return;
      }

      if(strstr(buf,"access_log") != 0) {
	 if(strstr(buf,"realtime_access_log_lines") == 0) {
            getword(wbuf,buf,' ',sizeof(wbuf));
            strcpy(AccessLog,buf);
            fixnone(AccessLog);
            return;
         }
      }

      if(strstr(buf,"useragent_log") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(UserAgentLog,buf);
         fixnone(UserAgentLog);
         return;
      }

      if(strstr(buf,"exclude_hosts") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ExcludeHosts,buf);
         fixnone(ExcludeHosts);
         return;
      }

      if(strstr(buf,"exclude_codes") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ExcludeCodes,buf);
         fixnone(ExcludeCodes);
         return;
      }

      if(strstr(buf,"exclude_users") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ExcludeUsers,buf);
         fixnone(ExcludeUsers);
         return;
      }

      if(strstr(buf,"password") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(PasswdFile,buf);
         fixnone(PasswdFile);
         return;
      }

      if(strstr(buf,"temporary_dir") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(TempDir,buf);
         fixnone(TempDir);
         return;
      }

      if(strstr(buf,"report_type") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ReportType,buf);
         fixnone(ReportType);
         return;
      }

      if(strstr(buf,"output_dir") != 0) {
         if(strstr(buf,"output_dir_form") == 0) {
            getword(wbuf,buf,' ',sizeof(wbuf));
            strcpy(OutputDir,buf);
            fixnone(OutputDir);
            return;
         }
      }

      if(strstr(buf,"output_email") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(OutputEmail,buf);
         fixnone(OutputEmail);
         return;
      }

      if(strstr(buf,"per_user_limit") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         getword(PerUserLimitFile,buf,' ',sizeof(PerUserLimitFile));
         strcpy(PerUserLimit,buf);
         fixnone(PerUserLimitFile);
         fixnone(PerUserLimit);
         return;
      }


      if(strstr(buf,"lastlog") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(LastLog,buf);
         fixnone(LastLog);
         return;
      }

      if(strstr(buf,"remove_temp_files") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(RemoveTempFiles,buf);
         fixnone(RemoveTempFiles);
         return;
      }

      if(strstr(buf,"replace_index") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ReplaceIndex,buf);
         fixnone(ReplaceIndex);
         return;
      }      

      if(strstr(buf,"index_tree") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(IndexTree,buf);
         fixnone(IndexTree);
         return;
      }      

      if(strstr(buf,"index") != 0) {
         if(strstr(buf,"index_sort_order") == 0) {
            getword(wbuf,buf,' ',sizeof(wbuf));
            strcpy(Index,buf);
            fixnone(Index);
            return;
         }
      }

      if(strstr(buf,"overwrite_report") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(OverwriteReport,buf);
         fixnone(OverwriteReport);
         return;
      }

      if(strstr(buf,"records_without_userid") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(RecordsWithoutUser,buf);
         fixnone(RecordsWithoutUser);
         return;
      }

      if(strstr(buf,"use_comma") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(UseComma,buf);
         fixnone(UseComma);
         return;
      }

      if(strstr(buf,"mail_utility") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(MailUtility,buf);
         fixnone(MailUtility);
         return;
      }

      if(strstr(buf,"topsites_num") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(TopSitesNum,buf);
         fixnone(TopSitesNum);
         return;
      }

      if(strstr(buf,"topuser_num") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(TopUsersNum,buf);
         fixnone(TopUsersNum);
         return;
      }

      if(strstr(buf,"usertab") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(UserTabFile,buf);
         fixnone(UserTabFile);
         return;
      }

      if(strstr(buf,"index_sort_order") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(IndexSortOrder,buf);
         fixnone(IndexSortOrder);
         return;
      }

      if(strstr(buf,"topsites_sort_order") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         getword(TopsitesSortField,buf,' ',sizeof(TopsitesSortField));
         strcpy(TopsitesSortType,buf);
         fixnone(TopsitesSortField);
         fixnone(TopsitesSortType);
         return;
      }

      if(strstr(buf,"long_url") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(LongUrl,buf);
         fixnone(LongUrl);
         return;
      }

      if(strstr(buf,"language") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(language,buf);
         fixnone(language);
         return;
      }

      if(strstr(buf,"dansguardian_conf") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(DansGuardianConf,buf);
         fixnone(DansGuardianConf);
         return;
      }

      if(strstr(buf,"squidguard_conf") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(SquidGuardConf,buf);
         fixnone(SquidGuardConf);
         return;
      }

      if(strstr(buf,"date_time_by") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(datetimeby,buf);
         fixnone(datetimeby);
         return;
      }

      if(strstr(buf,"charset") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(CharSet,buf);
         fixnone(CharSet);
         ccharset(CharSet);
         return;
      }

      if(strstr(buf,"user_invalid_char") != 0) {
         getword(wbuf,buf,'"',sizeof(wbuf));
         getword(UserInvalidChar,buf,'"',sizeof(UserInvalidChar));
         fixnone(UserInvalidChar);
         return;
      }

      if(strstr(buf,"include_users") != 0) {
         getword(wbuf,buf,'"',sizeof(wbuf));
         getword(wbuf,buf,'"',sizeof(wbuf));
	 sprintf(IncludeUsers,":%s:",wbuf);
         fixnone(IncludeUsers);
         return;
      }

      if(strstr(buf,"exclude_string") != 0) {
         getword(wbuf,buf,'"',sizeof(wbuf));
         getword(ExcludeString,buf,'"',sizeof(ExcludeString));
         fixnone(ExcludeString);
         return;
      }

      if(strstr(buf,"privacy") != 0) {
         if(strstr(buf,"privacy_string") == 0 && \
	    strstr(buf,"privacy_string_color") == 0) {
            getword(wbuf,buf,' ',sizeof(wbuf));
            strcpy(Privacy,buf);
            fixnone(Privacy);
            return;
	 }
      }

      if(strstr(buf,"privacy_string") != 0) {
	 if(strstr(buf,"privacy_string_color") == 0) {
            getword(wbuf,buf,'"',sizeof(wbuf));
            getword(PrivacyString,buf,'"',sizeof(PrivacyString));
            fixnone(PrivacyString);
            return;
	 }
      }

      if(strstr(buf,"privacy_string_color") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(PrivacyStringColor,buf);
         fixnone(PrivacyStringColor);
         return;
      }

      if(strstr(buf,"show_successful_message") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(SuccessfulMsg,buf);
         fixnone(SuccessfulMsg);
         return;
      }

      if(strstr(buf,"show_read_statistics") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ShowReadStatistics,buf);
         fixnone(ShowReadStatistics);
         return;
      }

      if(strstr(buf,"topuser_fields") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(TopUserFields,buf);
         fixnone(TopUserFields);
         return;
      }

      if(strstr(buf,"bytes_in_sites_users_report") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(BytesInSitesUsersReport,buf);
         fixnone(BytesInSitesUsersReport);
         return;
      }

      if(strstr(buf,"user_report_fields") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(UserReportFields,buf);
         fixnone(UserReportFields);
         return;
      }

      if(strstr(buf,"bytes_in_sites_users_report") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(BytesInSitesUsersReport,buf);
         fixnone(BytesInSitesUsersReport);
         return;
      }

      if(strstr(buf,"datafile ") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(DataFile,buf);
         fixnone(DataFile);
         return;
      }

      if(strstr(buf,"datafile_delimiter") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         getword(wbuf,buf,'"',sizeof(wbuf));
         getword(DataFileDelimiter,buf,'"',sizeof(DataFileDelimiter));
         fixnone(DataFileDelimiter);
         return;
      }

      if(strstr(buf,"datafile_fields") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(DataFileFields,buf);
         fixnone(DataFileFields);
         return;
      }

      if(strstr(buf,"datafile_url") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(DataFileUrl,buf);
         fixnone(DataFileUrl);
         return;
      }

      if(strstr(buf,"parsed_output_log") != 0) {
	 if(strstr(buf,"parsed_output_log_compress") == 0) {
            getword(wbuf,buf,' ',sizeof(wbuf));
            strcpy(ParsedOutputLog,buf);
            fixnone(ParsedOutputLog);
            return;
         }
      }

      if(strstr(buf,"parsed_output_log_compress") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ParsedOutputLogCompress,buf);
         fixnone(ParsedOutputLogCompress);
         return;
      }

      if(strstr(buf,"displayed_values") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(DisplayedValues,buf);
         fixnone(DisplayedValues);
         return;
      }

      if(strstr(buf,"authfail_report_limit") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         AuthfailReportLimit=atoi(buf);
         return;
      }

      if(strstr(buf,"denied_report_limit") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         DeniedReportLimit=atoi(buf);
         return;
      }

      if(strstr(buf,"siteusers_report_limit") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         SiteUsersReportLimit=atoi(buf);
         return;
      }

      if(strstr(buf,"dansguardian_report_limit") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         DansGuardianReportLimit=atoi(buf);
         return;
      }

      if(strstr(buf,"squidguard_report_limit") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         SquidGuardReportLimit=atoi(buf);
         return;
      }

      if(strstr(buf,"user_report_limit") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         UserReportLimit=atoi(buf);
         return;
      }

      if(strstr(buf,"download_report_limit") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         DownloadReportLimit=atoi(buf);
         return;
      }

      if(strstr(buf,"www_document_root") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(wwwDocumentRoot,buf);
         fixnone(wwwDocumentRoot);
         return;
      }

      if(strstr(buf,"block_it") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(BlockIt,buf);
         fixnone(BlockIt);
         return;
      }

      if(strstr(buf,"external_css_file") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(ExternalCSSFile,buf);
         fixnone(ExternalCSSFile);
         return;
      }

      if(strstr(buf,"user_authentication") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(UserAuthentication,buf);
         fixnone(UserAuthentication);
         return;
      }

      if(strstr(buf,"AuthUserFile") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(AuthUserFile,buf);
         fixnone(AuthUserFile);
         return;
      }

      if(strstr(buf,"AuthName") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(AuthName,buf);
         fixnone(AuthName);
         return;
      }

      if(strstr(buf,"AuthType") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(AuthType,buf);
         fixnone(AuthType);
         return;
      }

      if(strstr(buf,"Require") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(Require,buf);
         fixnone(Require);
         return;
      }

      if(strstr(buf,"download_suffix") != 0) {
         getword(wbuf,buf,'"',sizeof(wbuf));
         getword(DownloadSuffix,buf,'"',sizeof(DownloadSuffix));
         fixnone(DownloadSuffix);
         return;
      }

      if(strstr(buf,"graphs") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(Graphs,buf);
         fixnone(Graphs);
         return;
      }

      if(strstr(buf,"graph_days_bytes_bar_color") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(GraphDaysBytesBarColor,buf);
         fixnone(GraphDaysBytesBarColor);
         return;
      }

      if(strstr(buf,"squidguard_log_format") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(SquidGuardLogFormat,buf);
         fixnone(SquidGuardLogFormat);
         return;
      }

      if(strstr(buf,"squidguard_ignore_date") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(SquidguardIgnoreDate,buf);
         fixnone(SquidguardIgnoreDate);
         return;
      }

      if(strstr(buf,"dansguardian_ignore_date") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(DansguardianIgnoreDate,buf);
         fixnone(DansguardianIgnoreDate);
         return;
      }

      if(strstr(buf,"ulimit") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(Ulimit,buf);
         fixnone(Ulimit);
         return;
      }

      if(strstr(buf,"ntlm_user_format") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(NtlmUserFormat,buf);
         fixnone(NtlmUserFormat);
         return;
      }

      if(strstr(buf,"realtime_types") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(RealtimeTypes,buf);
         fixnone(RealtimeTypes);
         return;
      }

      if(strstr(buf,"realtime_unauthenticated_records") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         strcpy(RealtimeUnauthRec,buf);
         fixnone(RealtimeUnauthRec);
         return;
      }

      if(strstr(buf,"realtime_refresh_time") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         realtime_refresh=atoi(buf);
         return;
      }

      if(strstr(buf,"realtime_access_log_lines") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         realtime_access_log_lines=atoi(buf);
         return;
      }

      if(strstr(buf,"squid24") != 0) {
         squid24++;
         return;
      }

      if(strstr(buf,"byte_cost") != 0) {
         getword(wbuf,buf,' ',sizeof(wbuf));
         cost=atol(buf);
         getword(wbuf,buf,' ',sizeof(wbuf));
         nocost=my_atoll(buf);
         return;
      }
}

void getconf()
{

   FILE *fp_in;
   char buf[MAXLEN];

   if(debug) {
      sprintf(Msg,"Loading configuration from: %s",ConfigFile);
      debuga(Msg);
   }

   if ((fp_in = fopen(ConfigFile, "r")) == NULL) {
      fprintf(stderr, "SARG: (getconf) Cannot open file: %s\n",ConfigFile);
      exit(1);
   }

   while (fgets(buf, MAXLEN, fp_in) != NULL) {
      if(strstr(buf,"\n") != 0)
         buf[strlen(buf)-1]='\0';

      if(debugm)
         printf("SYSCONFDIR %s",buf);

      if(strncmp(buf,"#",1) == 0 || strlen(buf) < 1)
         continue;

      if(debugz)
         printf("SARG: TAG: %s\n",buf);

      parmtest(buf);

   }

   fclose(fp_in);
   language_load(language);
   return;
}
